$!============================================================
$! title  : rdb_demo3_create_db_step1.com
$! author : Neil Rieck
$! created: 2004-09-18
$!============================================================
$	say :== write sys$output
$	ask :== inquire/nopunct
$	bel[0,8]==7
$	on warn then goto error
$	set on
$	say ""
$	say "rdb_demo3_create_db_step1.com"
$	say "============================="
$	temp = f$trnlnm("csmis$dat")			! does this logical exist?
$	if temp .eqs. ""				! nope
$	then						!
$		temp2 = f$environment("DEFAULT")	!
$		def/sys/log csmis$dat 'temp2'		! so create file in current directory
$	endif						!
$	temp = f$search("csmis$dat:rdb_demo3_db.rdb")	!
$	if temp .nes. "" 
$	then
$		say "-w- warning: database 'csmis$dat:rdb_demo3_db.rdb' already exists"
$		say "    and continuing will create a new database over the old one"
$		ask choice "Continue? (y/N) "
$		choice = f$extract(0,1,choice)
$		if choice .nes. "Y" then goto fini
$	endif
$	set ver
$sql$					! this will only work if '@sys$library:RDBVMS_SETVER.COM reset' has been run
!
!	WARNING: if the database already exists, this command will create another new one
!
create database filename csmis$dat:rdb_demo3_db.rdb
	number of users 500		! number of connections (e.g. 125 users x 4 connections each)
	number of cluster nodes 16;	! if not in an OpenVMS cluster then setting to 1 will improve preformance
!----------------------------------------------------------------------------------------------------
!	create stuff for asset
!----------------------------------------------------------------------------------------------------
create table asset (	d131_rfa		integer      ,
			d131_status		varchar(   1),
			d131_system_name	varchar(  15),
			d131_station		varchar(  15),
			d131_device_name 	varchar(  20),
			d131_serial      	varchar(  15),
			d131_client      	varchar(  25),
			d131_contract		varchar(  10),
			d131_clli		varchar(  12),
			d131_installed_date 	varchar(   8),
			d131_warranty_exp   	varchar(   8),
			d131_flr		varchar(   9),
			d131_address		varchar(  37),
			d131_city		varchar(  15),
			d131_name		varchar(  35),
			d131_postal_code 	varchar(   6),
			d131_telephone		varchar(  10),
			d131_prov		varchar(   4),
			d131_severity		varchar(   4),
			d131_loc		varchar(   6),
			d131_est		varchar(   7),
			d131_toe		varchar(   3),
			d131_org		varchar(   8),
			d131_netterm          	varchar(  12),
			d131_mac_address 	varchar(  15),
			d131_circuit     	varchar(  22),
			d131_notes		varchar(  71),
			d131_spare      	varchar(  53));
!
!	this entry generates a fake rfa for use with our software
create sequence rfa_131_seq start with 1;
!----------------------------------------------------------------------------------------------------
! notes: 1. defining a primary key in RMS automatically creates an index
!        2. defining a primary key in SQL only creates a constraint. To improve constraint
!           performance an index should be created against the field(s) referenced by the constraint
!        3. sometimes a UNIQUE INDEX will be more efficient than declaring a primary key with an
!           attached index. For example, indexes are changeable while primary keys are not.
!----------------------------------------------------------------------------------------------------
!	2400 records requires 3 seconds (on an AlphaServer-4100)
create unique index ASSETRFA on ASSET (d131_rfa);
!
!	2400 records requires 4 seconds (on an AlphaServer-4100)
! alter table asset add constraint primary key (d131_rfa) initially deferred deferrable;
! create unique index ASSETRFA on ASSET (d131_rfa);
!
!	2400 records requires 167 seconds (on an AlphaServer-4100)
! alter table asset add constraint primary key (d131_rfa) initially immediate not deferrable;
!
!	2400 records requires 336 seconds (on an AlphaServer-4100)
! alter table asset add constraint primary key (d131_rfa) initially deferred deferrable;
!
commit;
!----------------------------------------------------------------------------------------------------
!	create stuff to support asset-history
!----------------------------------------------------------------------------------------------------
create table asset_history(
	d133_rfa		integer,
	d133_system_name 	varchar(  15),
	d133_station		varchar(  15),
	d133_date		varchar(  14),
	d133_status		varchar(   1),
	d133_initial		varchar(   3),
	d133_text		varchar(  59));
!
!	this entry generates a fake rfa for use with our software
create sequence rfa_133_seq start with 1;
!
create unique index ASSET_HISTORY_RFA on ASSET_HISTORY (d133_rfa);
commit;
!
exit
$fini:
$	set nover
$	say "",bel
$	say "======================================================================"
$	say "Note: part-2 creates the necessary indexes required by our application"
$	say "======================================================================"
$	ask choice "Run the part-2 script now? (Y/n) "
$	choice = f$edit(choice,"UPCASE,COLLAPSE")
$	choice = f$extract(0,1,choice)
$	if choice .eqs. "Y"
$	then
$		@rdb_demo3_create_db_step2.com
$	endif
$ 	exit
$!
$error:
$	set nover
$	say '-e- did you execute the script '@sys$library:RDBVMS_SETVER.COM reset' ?'
$	exit
