$!============================================================
$! title  : rdb_demo3_create_db_step2.com
$! author : Neil Rieck
$! created: 2004-09-11
$!============================================================
$	say :== write sys$output
$	ask :== inquire/nopunct
$	bel[0,8]==7
$	on warn then goto error
$	set on
$	say ""
$	say "rdb_demo3_create_db_step2.com"
$	say "============================="
$	temp = f$trnlnm("csmis$dat")			! does this logical exist?
$	if temp .eqs. ""				! nope
$	then						!
$		temp2 = f$environment("DEFAULT")	!
$		def/sys/log csmis$dat 'temp2'		! so create file in current directory
$	endif						!
$	temp = f$search("csmis$dat:rdb_demo3_db.rdb")	!
$	if temp .eqs. "" 
$	then
$		say "-e- error: database 'csmis$dat:rdb_demo3_db.rdb' was not found"
		exit
$	endif
$	set ver
$sql$					! this will only work if '@sys$library:RDBVMS_SETVER.COM reset' has been run
!
attach 'filename csmis$dat:rdb_demo3_db';
!----------------------------------------------------------------------------------------------------
!	stuff to support ASSET (these are the same keys use by ICSIS application ASSETDB_xxxx.BAS)
!
! notes: 1. defining a primary key in RMS automatically creates an index
!        2. defining a primary key in SQL only creates a constraint. To improve constraint
!           performance an index should be created against the field(s) referenced by the constraint
!	 3. sometimes, a UNIQUE INDEX will be more efficient than declaring a primary key with an
!	    attached index. For example, indexes are changeable while primary keys are not.
!----------------------------------------------------------------------------------------------------
create UNIQUE INDEX key0 on asset (d131_system_name,d131_station);
commit;
!
create        INDEX key1 on asset (d131_station);
commit;
!
create        INDEX key2 on asset (d131_clli);
commit;
!
create        INDEX key3 on asset (d131_serial);
commit;
!
create        INDEX key4 on asset (d131_netterm);
commit;
!
create        INDEX key5 on asset (d131_circuit);
commit;
!----------------------------------------------------------------------------------------------------
!	stuff to support ASSET-HISTORY
!----------------------------------------------------------------------------------------------------
!
!	when we pull up asset history in a scrolling window,
!	we usually do the lookup by system_name = station then reverse sort by date
!	this index should speed up history lookups.
!
create        index ASSET_HISTORY_KEY1 on ASSET_HISTORY (d133_system_name,d133_station,d133_date descending);
commit;
exit
$fini:
$	set nover
$ 	exit
$!
$error:
$	set nover
$	say '-e- did you execute the script '@sys$library:RDBVMS_SETVER.COM reset' ?'
$	exit
