1000	%title "RDB_DEMO3_view_assets_xxx.bas"
	%ident					"100.1"
	declare string constant k_version =	"100.1"
	!========================================================================================================================
	! title  : RDB_DEMO3_view_assets_xxx.bas
	! author : Neil Rieck		(http://www3.sympatico.ca/n.rieck)
	! purpose: This demo views the contents of 2 Oracle Rdb tables (so we can develop some skills)
	! notes  : this program calls SUB procedures created in RDB_DEMO3_view_assets_xxx_bas.SQLMOD
	! history:
	! ver who when   what
	! --- --- ------ --------------------------------------------------------------------------------------------------------
	! 100 NSR 040923 1. original program
	!========================================================================================================================
	! DCL Build Instructions:
	!	DCL command:						Result:
	!	--------------------------------------------		------------------------------------
	!	basic	rdb_demo3_view_assets_xxx.bas			rdb_demo3_view_assets_xxx.obj
	!	sql$mod	rdb_demo3_view_assets_bas_xxx.sqlmod		rdb_demo3_view_assets_bas_xxx.obj
	!	link	rdb_demo3_view_assets_xxx.obj		, -
	!		rdb_demo3_view_assets_bas_xxx.obj	, -
	!		SQL$USER/library				rdb_demo3_view_assets_xxx.exe
	!
	! note: "SQL$USER" is a special logical created by executing "@sys$library:RDBVMS_SETVER.COM reset" or
	!	"@csmis$com:RDB_INIT_ENVIRONMENT.COM". This logical is currently defined as "SYS$COMMON:[SYSLIB]SQL$USER71.OLB"
	!	which could change with different versions of RDB (many versions can co-exist on the same system) so never
	!	hard code the library specification. Always use logical "SQL$USER".
	!========================================================================================================================
	option type=explicit							! no tricks
	set no prompt								!
	declare string constant k_program = "RDB_DEMO3_view_assets"		!
	!
	%include "sys$library:SQL_LITERALS.BAS"					! end-of-stream etc. in SQLCODE
	%include "sys$library:COSIMSG.BAS"					!
	%include "sys$library:RDBMSGS.BAS"					!
	%include "sys$library:RDMSMSG.BAS"					!
	%include "sys$library:SQLSTATE.BAS"					! required with SQLSTATE
	%include "sys$library:SQL_MSG.BAS"					! 
	%include "sys$library:SQL_SQLCA.BAS"					! Sql Communications Area (SCA)
	!
	!	this file contains map for our old RMS file definitions (which are also used by our Rdb)
	!	as well as our FMS maps
	!
	%include "RDB_demo3_ASSETDB_2014.REC"					! rms asset record declarations
	!
	declare	long	i%			,&
			j%			,&
			rc%			,&
			be%			,&
			file31_open%		,&
			file33_open%		,&
			read_only%		,&
			counter%		,&
			commit_every_insert%	,&
			d131_rfa%		,&
		double	time0			,&
			time1			,&
		string	default_node$		,&
			default_dir$		,&
			junk$
	!
	!				++-------- class code		see "sys$library:SQLSTATE.BAS" for more codes
	!				||+++----- sub-class code
	!	some SQLSTATE values:	00000 success
	!				01000 warning
	!				02000 no more data
	!				2200F zero-length string
	!				0H000 Invalid SQL state
	!				S7000 bad version
	!
	map(sqlstate)	string sql_state	= 5				! from SQLSTATE (a 5 char string)
	map(sqlstate)	string sql_class	= 2	,&
			string sql_subclass	= 3
	!
	!
	!	these SUB procedures represent routines defined in file 'RDB_DEMO3_view_assets_100_BAS.SQLMOD'
	!
	external sub SET_TRANSACTION(string)					! SQLSTATE
	external sub COMMIT_TRANSACTION(string)					! SQLSTATE
	external sub ROLLBACK_TRANSACTION(string)				! SQLSTATE
	external sub OPEN_ASSET_MAIN_ROW(string)				! SQLSTATE
	external sub FETCH_ASSET_MAIN_ROW(string,				! SQLSTATE					&
	    integer,								! rfa						&
	    string,string,string,string,string,string,string,string,string,	!						&
	    string,string,string,string,string,string,string,string,string,	!						&
	    string,string,string,string,string,string,string,string)		! 26 data fields
	external sub CLOSE_ASSET_MAIN_ROW(string)				! SQLSTATE
	!
	!----------------------------------------------------------------------------------------------------
	!	main
	!----------------------------------------------------------------------------------------------------
	main:
	print k_program +"_"+ k_version
	print string$(len(k_program +"_"+ k_version), asc("="))
	print "-i- open cursor"
	call OPEN_ASSET_MAIN_ROW(sql_state)
	if sql_state <> "00000" then
	    print "-e- OPEN_ASSET_MAIN_ROW: ";sql_state
	    goto handle_basic_error1
	end if
	print "-i- first fetch cursor"
	when error in
	    while 1
		call FETCH_ASSET_MAIN_ROW(									&
		    sql_state,							! SQLSTATE			&
		    d131_rfa%		    ,					! pseudo RFA (from SEQUENCE)	&
		    d131_status             ,					! start of 26 items		&
		    d131_system_name        ,&
		    d131_station            ,&
		    d131_device_name        ,&
		    d131_serial             ,&
		    d131_client             ,&
		    d131_contract           ,&
		    d131_clli               ,&
		    d131_installed_date     ,&
		    d131_warranty_exp       ,&
		    d131_flr                ,&
		    d131_address            ,&
		    d131_city               ,&
		    d131_name               ,&
		    d131_postal_code        ,&
		    d131_telephone          ,&
		    d131_prov               ,&
		    d131_severity           ,&
		    d131_loc                ,&
		    d131_est                ,&
		    d131_toe                ,&
		    d131_org                ,&
		    d131_netterm            ,&
		    d131_mac_address        ,&
		    d131_circuit            ,&
		    d131_notes              )
		if sql_state <> "00000" then
		    print "-e- FETCH_ASSET_MAIN_ROW: ";sql_state
		    goto handle_basic_error1
		end if
		print "-i- data ===================="
		print "Sequence   : "; str$(d131_rfa%)
		print "Status     : "; d131_status
		print "System_Name: "; d131_system_name
		print "Station    : "; d131_station
		print "Device_Name: "; d131_device_name
		if junk$ <> "C" then						! if not C/ontinuous mode
		    input "More? (Y/es, N/o, C/ontinuous) "; junk$
		    junk$ = left$( edit$(junk$,32+2), 1)
		    select left$(junk$,1)
			case "N"
			    be% = 0						! flag as 'no error'
			    goto handle_basic_error1
			case "A"
			    print "-i- C/ontinuous mode on"
			    sleep 1
		    end select
		end if
	next
	use
	    be% = err								! remember this 'Basic Error'
	end when
	!
	handle_basic_error1:
	select be%								! test 'Basic Error'
	    case 0								! no error
	    case else
		print "-e-Unexpected Error: "+ str$(be%) +" Text: "+ ert$(be%)
		print "-i-Attempting Rdb ROLLBACK"
		call ROLLBACK_TRANSACTION(sql_state)
		if sql_state <> "00000" then
		    print "-e- ROLLBACK: ";sql_state
		    goto fini
		else
		    print "-i- ROLLBACK was successful"
		end if
	end select
	!
	!	this stub probably isn't required before an exit, but I put it here to show how to do it
	!
	print "-i- close cursor"
	call CLOSE_ASSET_MAIN_ROW(sql_state)
	if sql_state <> "00000" then
	    print "-e- CLOSE_ASSET_MAIN_ROW: ";sql_state
	end if
	!
	!----------------------------------------------------------------------------------------------------
	!	adios
	!----------------------------------------------------------------------------------------------------
	fini:
	end
